/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_EMPR                                                     */
/* Tabela : EMPRESA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_EMPR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_EMPR
GO

CREATE TRIGGER DTULTATU_EMPR
ON EMPRESA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'EMPRESA', null, 'CDEMPRESA=' + CDEMPRESA + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE EMPRESA
      SET DTULTATUEMPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(EMPRESA.CDEMPRESA,0) = ISNULL(INSERTED.CDEMPRESA,0)) AND
            (ISNULL(EMPRESA.NMEMPRESA,0) = ISNULL(INSERTED.NMEMPRESA,0)) AND
            (ISNULL(EMPRESA.VRPEMOREMPR,0) = ISNULL(INSERTED.VRPEMOREMPR,0)) AND
            (ISNULL(EMPRESA.CDCENTCUST,0) = ISNULL(INSERTED.CDCENTCUST,0)) AND
            (ISNULL(EMPRESA.NMRAZSOCEMPR,0) = ISNULL(INSERTED.NMRAZSOCEMPR,0)) AND
            (ISNULL(EMPRESA.NRINSJUREMPR,0) = ISNULL(INSERTED.NRINSJUREMPR,0)) AND
            (ISNULL(EMPRESA.IDTPIJUREMPR,0) = ISNULL(INSERTED.IDTPIJUREMPR,0)) AND
            (ISNULL(EMPRESA.CDINSCESTA,0) = ISNULL(INSERTED.CDINSCESTA,0)) AND
            (ISNULL(EMPRESA.CDINSCMUNI,0) = ISNULL(INSERTED.CDINSCMUNI,0)) AND
            (ISNULL(EMPRESA.VRPEMULEMPR,0) = ISNULL(INSERTED.VRPEMULEMPR,0));
   END;
END;
GO

UPDATE EMPRESA SET DTULTATUEMPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUEMPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUEMPR' and
            type = 'D')
   ALTER TABLE EMPRESA DROP CONSTRAINT DEFAULT_DTULTATUEMPR
GO

ALTER TABLE EMPRESA ADD CONSTRAINT DEFAULT_DTULTATUEMPR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUEMPR
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_EMPR','4.11.194';
GO

